﻿using System;
using System.Windows.Forms;

namespace StradusUSBHIDTestApp
{
    public partial class Form1 : Form
    {
        StradusUSBHID.StradusHub myHub;
        String TermLineBuff1=String.Empty;
        String TermLineBuff2=String.Empty;
        String TermLineBuff3=String.Empty;
        String TermLineBuff4=String.Empty;
        bool[] isPending = new bool[4];

        public Form1()
        {
            InitializeComponent();

            myHub = new StradusUSBHID.StradusHub();
            myHub.InitStradusHub();
            isPending[0] = false;
            isPending[1] = false;
            isPending[2] = false;
            isPending[3] = false;
            timer1.Start();
        }

//Delegates to update textboxes with data retrieved from Stradus lasers.
#region TEXTBOX UPDATE DELEGATES

        //TextBox1
        delegate void GetData(string getDataFromBuffer);

        private void UpdateTextBox1(string p)
        {
            if (textBox1.InvokeRequired)
                textBox1.Invoke(new GetData(UpdateTextBox1), new object[] { p });
            else
                textBox1.AppendText(p.Replace("\n","\r\n"));
        }

        //TextBox2
        delegate void GetData2(string getDataFromBuffer);

        private void UpdateTextBox2(string p)
        {
            if (textBox2.InvokeRequired)
                textBox2.Invoke(new GetData2(UpdateTextBox2), new object[] { p });
            else
                textBox2.AppendText(p.Replace("\n", "\r\n"));
        }

        //TextBox3
        delegate void GetData3(string getDataFromBuffer);

        private void UpdateTextBox3(string p)
        {
            if (textBox3.InvokeRequired)
                textBox3.Invoke(new GetData3(UpdateTextBox3), new object[] { p });
            else
                textBox3.AppendText(p.Replace("\n", "\r\n"));
        }

        //TextBox4
        delegate void GetData4(string getDataFromBuffer);

        private void UpdateTextBox4(string p)
        {
            if (textBox4.InvokeRequired)
                textBox4.Invoke(new GetData4(UpdateTextBox4), new object[] { p });
            else
                textBox4.AppendText(p.Replace("\n", "\r\n"));
        }
        #endregion

//Event handlers for detecting key strokes for the active textbox.
#region TEXTBOX KEYBOARD EVENT HANDLERS

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
                //Buffer each line then send entire line upon pressing enter
                if (e.KeyChar == (char)Keys.Enter)
                {
                    myHub.StradusSend(0,TermLineBuff1+"\r");//Terminal Window
                    TermLineBuff1 = "";
                    isPending[0] = true;
                }
                else
                {
                    textBox1.AppendText(e.KeyChar.ToString());
                    TermLineBuff1 += e.KeyChar;
                }           
        }

        private void textBox2_KeyPress(object sender, KeyPressEventArgs e)
        {
            //Buffer each line then send entire line upon pressing enter
            if (e.KeyChar == (char)Keys.Enter)
            {
                myHub.StradusSend(1, TermLineBuff2 + "\r");//Terminal Window
                TermLineBuff2 = "";
                isPending[1] = true;
            }
            else
            {
                textBox2.AppendText(e.KeyChar.ToString());
                TermLineBuff2 += e.KeyChar;
            }  
        }

        private void textBox3_KeyPress(object sender, KeyPressEventArgs e)
        {
            //Buffer each line then send entire line upon pressing enter
            if (e.KeyChar == (char)Keys.Enter)
            {
                myHub.StradusSend(2, TermLineBuff3 + "\r");//Terminal Window
                TermLineBuff3 = "";
                isPending[2] = true;
            }
            else
            {
                textBox3.AppendText(e.KeyChar.ToString());
                TermLineBuff3 += e.KeyChar;
            }  
        }

        private void textBox4_KeyPress(object sender, KeyPressEventArgs e)
        {
            //Buffer each line then send entire line upon pressing enter
            if (e.KeyChar == (char)Keys.Enter)
            {
                myHub.StradusSend(3, TermLineBuff4 + "\r");//Terminal Window
                TermLineBuff4 = "";
                isPending[3] = true;
            }
            else
            {
                textBox4.AppendText(e.KeyChar.ToString());
                TermLineBuff4 += e.KeyChar;
            }
        }
#endregion

        //Timer 1 provides a timebase for retrieving replies from lasers
        //and displaying the new data on the windows form.
        private void timer1_Tick(object sender, EventArgs e)
        {
            String str0, str1, str2, str3;
            if (isPending[0])
            {              
                str0 = myHub.StradusGetReply(0);
                if (str0 != "EMPTY")
                {
                    isPending[0] = false;
                    UpdateTextBox1(str0);
                }
            }
            if (isPending[1])
            {
                str1 = myHub.StradusGetReply(1);
                if (str1 != "EMPTY")
                {
                    isPending[1] = false;
                    UpdateTextBox2(str1);
                }
            }
            if (isPending[2])
            {
                str2 = myHub.StradusGetReply(2);
                if (str2 != "EMPTY")
                {
                    isPending[2] = false;
                    UpdateTextBox3(str2);
                }
            }
            if (isPending[3])
            {
                str3 = myHub.StradusGetReply(3);
                if (str3 != "EMPTY")
                {
                    isPending[3] = false;
                    UpdateTextBox4(str3);
                }
            }

            label1.Text = " "+ myHub.StradusCount+" Lasers Connected";
        }

        //Clears all text from textboxes.
        private void button1_Click(object sender, EventArgs e)
        {
            textBox1.Clear();
            textBox2.Clear();
            textBox3.Clear();
            textBox4.Clear();

        }



    }
}
